(function(e,t){'object'==typeof exports&&'undefined'!=typeof module?t(exports,require('preact'),require('chart.js')):'function'==typeof define&&define.amd?define(['exports','preact','chart.js'],t):t(e.PreactChartjs2={},e.Preact,e.Chart)})(this,function(e,t,n){'use strict';/**
 * Creates an list cache object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 *//**
 * Checks if a list cache value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf ListCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 *//**
 * Removes `key` and its value from the list cache.
 *
 * @private
 * @name delete
 * @memberOf ListCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 *//**
 * Performs a
 * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * comparison between two values to determine if they are equivalent.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 * @example
 *
 * var object = { 'a': 1 };
 * var other = { 'a': 1 };
 *
 * _.eq(object, object);
 * // => true
 *
 * _.eq(object, other);
 * // => false
 *
 * _.eq('a', 'a');
 * // => true
 *
 * _.eq('a', Object('a'));
 * // => false
 *
 * _.eq(NaN, NaN);
 * // => true
 */function a(e){var t=-1,n=null==e?0:e.length;for(this.clear();++t<n;){var a=e[t];this.set(a[0],a[1])}}// Add methods to `ListCache`.
/**
 * Sets the list cache `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf ListCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the list cache instance.
 *//**
 * Gets the list cache value for `key`.
 *
 * @private
 * @name get
 * @memberOf ListCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 *//**
 * Gets the index at which the `key` is found in `array` of key-value pairs.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {*} key The key to search for.
 * @returns {number} Returns the index of the matched value, else `-1`.
 *//**
 * Removes all key-value entries from the list cache.
 *
 * @private
 * @name clear
 * @memberOf ListCache
 *//**
 * Removes all key-value entries from the stack.
 *
 * @private
 * @name clear
 * @memberOf Stack
 *//**
 * Removes `key` and its value from the stack.
 *
 * @private
 * @name delete
 * @memberOf Stack
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 *//**
 * Gets the stack value for `key`.
 *
 * @private
 * @name get
 * @memberOf Stack
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 *//**
 * Checks if a stack value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf Stack
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */function o(e,t){return t={exports:{}},e(t,t.exports),t.exports}/** Detect free variable `global` from Node.js. *//**
 * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the raw `toStringTag`.
 *//**
 * Converts `value` to a string using `Object.prototype.toString`.
 *
 * @private
 * @param {*} value The value to convert.
 * @returns {string} Returns the converted string.
 *//**
 * The base implementation of `getTag` without fallbacks for buggy environments.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 *//**
 * Checks if `value` is the
 * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
 * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
 * @example
 *
 * _.isObject({});
 * // => true
 *
 * _.isObject([1, 2, 3]);
 * // => true
 *
 * _.isObject(_.noop);
 * // => true
 *
 * _.isObject(null);
 * // => false
 *//**
 * Checks if `value` is classified as a `Function` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a function, else `false`.
 * @example
 *
 * _.isFunction(_);
 * // => true
 *
 * _.isFunction(/abc/);
 * // => false
 *//**
 * Checks if `func` has its source masked.
 *
 * @private
 * @param {Function} func The function to check.
 * @returns {boolean} Returns `true` if `func` is masked, else `false`.
 *//**
 * Converts `func` to its source code.
 *
 * @private
 * @param {Function} func The function to convert.
 * @returns {string} Returns the source code.
 *//**
 * The base implementation of `_.isNative` without bad shim checks.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a native function,
 *  else `false`.
 *//**
 * Gets the value at `key` of `object`.
 *
 * @private
 * @param {Object} [object] The object to query.
 * @param {string} key The key of the property to get.
 * @returns {*} Returns the property value.
 *//**
 * Gets the native function at `key` of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {string} key The key of the method to get.
 * @returns {*} Returns the function if it's native, else `undefined`.
 *//**
 * Removes all key-value entries from the hash.
 *
 * @private
 * @name clear
 * @memberOf Hash
 *//**
 * Removes `key` and its value from the hash.
 *
 * @private
 * @name delete
 * @memberOf Hash
 * @param {Object} hash The hash to modify.
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 *//**
 * Gets the hash value for `key`.
 *
 * @private
 * @name get
 * @memberOf Hash
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 *//**
 * Checks if a hash value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf Hash
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 *//**
 * Sets the hash `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf Hash
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the hash instance.
 *//**
 * Creates a hash object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */function r(e){var t=-1,n=null==e?0:e.length;for(this.clear();++t<n;){var a=e[t];this.set(a[0],a[1])}}// Add methods to `Hash`.
/**
 * Removes all key-value entries from the map.
 *
 * @private
 * @name clear
 * @memberOf MapCache
 *//**
 * Checks if `value` is suitable for use as unique object key.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is suitable, else `false`.
 *//**
 * Gets the data for `map`.
 *
 * @private
 * @param {Object} map The map to query.
 * @param {string} key The reference key.
 * @returns {*} Returns the map data.
 *//**
 * Removes `key` and its value from the map.
 *
 * @private
 * @name delete
 * @memberOf MapCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 *//**
 * Gets the map value for `key`.
 *
 * @private
 * @name get
 * @memberOf MapCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 *//**
 * Checks if a map value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf MapCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 *//**
 * Sets the map `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf MapCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the map cache instance.
 *//**
 * Creates a map cache object to store key-value pairs.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */function d(e){var t=-1,n=null==e?0:e.length;for(this.clear();++t<n;){var a=e[t];this.set(a[0],a[1])}}// Add methods to `MapCache`.
/**
 * Sets the stack `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf Stack
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the stack cache instance.
 *//**
 * Creates a stack cache object to store key-value pairs.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */function s(e){var t=this.__data__=new f(e);this.size=t.size}// Add methods to `Stack`.
/**
 * Adds `value` to the array cache.
 *
 * @private
 * @name add
 * @memberOf SetCache
 * @alias push
 * @param {*} value The value to cache.
 * @returns {Object} Returns the cache instance.
 *//**
 * Checks if `value` is in the array cache.
 *
 * @private
 * @name has
 * @memberOf SetCache
 * @param {*} value The value to search for.
 * @returns {number} Returns `true` if `value` is found, else `false`.
 *//**
 *
 * Creates an array cache object to store unique values.
 *
 * @private
 * @constructor
 * @param {Array} [values] The values to cache.
 */function p(e){var t=-1,n=null==e?0:e.length;for(this.__data__=new le;++t<n;)this.add(e[t])}// Add methods to `SetCache`.
/**
 * A specialized version of `_.some` for arrays without support for iteratee
 * shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {boolean} Returns `true` if any element passes the predicate check,
 *  else `false`.
 *//**
 * Checks if a `cache` value for `key` exists.
 *
 * @private
 * @param {Object} cache The cache to query.
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 *//**
 * A specialized version of `baseIsEqualDeep` for arrays with support for
 * partial deep comparisons.
 *
 * @private
 * @param {Array} array The array to compare.
 * @param {Array} other The other array to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `array` and `other` objects.
 * @returns {boolean} Returns `true` if the arrays are equivalent, else `false`.
 *//**
 * Converts `map` to its key-value pairs.
 *
 * @private
 * @param {Object} map The map to convert.
 * @returns {Array} Returns the key-value pairs.
 *//**
 * Converts `set` to an array of its values.
 *
 * @private
 * @param {Object} set The set to convert.
 * @returns {Array} Returns the values.
 *//**
 * A specialized version of `baseIsEqualDeep` for comparing objects of
 * the same `toStringTag`.
 *
 * **Note:** This function only supports comparing values with tags of
 * `Boolean`, `Date`, `Error`, `Number`, `RegExp`, or `String`.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {string} tag The `toStringTag` of the objects to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 *//**
 * Appends the elements of `values` to `array`.
 *
 * @private
 * @param {Array} array The array to modify.
 * @param {Array} values The values to append.
 * @returns {Array} Returns `array`.
 *//**
 * The base implementation of `getAllKeys` and `getAllKeysIn` which uses
 * `keysFunc` and `symbolsFunc` to get the enumerable property names and
 * symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Function} keysFunc The function to get the keys of `object`.
 * @param {Function} symbolsFunc The function to get the symbols of `object`.
 * @returns {Array} Returns the array of property names and symbols.
 *//**
 * A specialized version of `_.filter` for arrays without support for
 * iteratee shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {Array} Returns the new filtered array.
 *//**
 * This method returns a new empty array.
 *
 * @static
 * @memberOf _
 * @since 4.13.0
 * @category Util
 * @returns {Array} Returns the new empty array.
 * @example
 *
 * var arrays = _.times(2, _.stubArray);
 *
 * console.log(arrays);
 * // => [[], []]
 *
 * console.log(arrays[0] === arrays[1]);
 * // => false
 *//**
 * The base implementation of `_.times` without support for iteratee shorthands
 * or max array length checks.
 *
 * @private
 * @param {number} n The number of times to invoke `iteratee`.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the array of results.
 *//**
 * Checks if `value` is object-like. A value is object-like if it's not `null`
 * and has a `typeof` result of "object".
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
 * @example
 *
 * _.isObjectLike({});
 * // => true
 *
 * _.isObjectLike([1, 2, 3]);
 * // => true
 *
 * _.isObjectLike(_.noop);
 * // => false
 *
 * _.isObjectLike(null);
 * // => false
 *//**
 * The base implementation of `_.isArguments`.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an `arguments` object,
 *//**
 * This method returns `false`.
 *
 * @static
 * @memberOf _
 * @since 4.13.0
 * @category Util
 * @returns {boolean} Returns `false`.
 * @example
 *
 * _.times(2, _.stubFalse);
 * // => [false, false]
 *//**
 * Checks if `value` is a valid array-like index.
 *
 * @private
 * @param {*} value The value to check.
 * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
 * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
 *//**
 * Checks if `value` is a valid array-like length.
 *
 * **Note:** This method is loosely based on
 * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
 * @example
 *
 * _.isLength(3);
 * // => true
 *
 * _.isLength(Number.MIN_VALUE);
 * // => false
 *
 * _.isLength(Infinity);
 * // => false
 *
 * _.isLength('3');
 * // => false
 *//**
 * The base implementation of `_.isTypedArray` without Node.js optimizations.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
 *//**
 * The base implementation of `_.unary` without support for storing metadata.
 *
 * @private
 * @param {Function} func The function to cap arguments for.
 * @returns {Function} Returns the new capped function.
 *//**
 * Creates an array of the enumerable property names of the array-like `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @param {boolean} inherited Specify returning inherited property names.
 * @returns {Array} Returns the array of property names.
 *//**
 * Checks if `value` is likely a prototype object.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.
 *//**
 * Creates a unary function that invokes `func` with its argument transformed.
 *
 * @private
 * @param {Function} func The function to wrap.
 * @param {Function} transform The argument transform.
 * @returns {Function} Returns the new function.
 *//**
 * The base implementation of `_.keys` which doesn't treat sparse arrays as dense.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 *//**
 * Checks if `value` is array-like. A value is considered array-like if it's
 * not a function and has a `value.length` that's an integer greater than or
 * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
 * @example
 *
 * _.isArrayLike([1, 2, 3]);
 * // => true
 *
 * _.isArrayLike(document.body.children);
 * // => true
 *
 * _.isArrayLike('abc');
 * // => true
 *
 * _.isArrayLike(_.noop);
 * // => false
 *//**
 * Creates an array of the own enumerable property names of `object`.
 *
 * **Note:** Non-object values are coerced to objects. See the
 * [ES spec](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
 * for more details.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Object
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.keys(new Foo);
 * // => ['a', 'b'] (iteration order is not guaranteed)
 *
 * _.keys('hi');
 * // => ['0', '1']
 *//**
 * Creates an array of own enumerable property names and symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names and symbols.
 *//**
 * A specialized version of `baseIsEqualDeep` for objects with support for
 * partial deep comparisons.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 *//**
 * A specialized version of `baseIsEqual` for arrays and objects which performs
 * deep comparisons and tracks traversed objects enabling objects with circular
 * references to be compared.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} [stack] Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 *//**
 * The base implementation of `_.isEqual` which supports partial comparisons
 * and tracks traversed objects.
 *
 * @private
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @param {boolean} bitmask The bitmask flags.
 *  1 - Unordered comparison
 *  2 - Partial comparison
 * @param {Function} [customizer] The function to customize comparisons.
 * @param {Object} [stack] Tracks traversed `value` and `other` objects.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 */function i(e,t,n,a,o){return!(e!==t)||(null!=e&&null!=t&&(De(e)||De(t))?Lt(e,t,n,a,i,o):e!==e&&t!==t)}/**
 * Performs a deep comparison between two values to determine if they are
 * equivalent.
 *
 * **Note:** This method supports comparing arrays, array buffers, booleans,
 * date objects, error objects, maps, numbers, `Object` objects, regexes,
 * sets, strings, symbols, and typed arrays. `Object` objects are compared
 * by their own, not inherited, enumerable properties. Functions and DOM
 * nodes are compared by strict equality, i.e. `===`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 * @example
 *
 * var object = { 'a': 1 };
 * var other = { 'a': 1 };
 *
 * _.isEqual(object, other);
 * // => true
 *
 * object === other;
 * // => false
 *//**
 * The base implementation of `_.isMatch` without support for iteratee shorthands.
 *
 * @private
 * @param {Object} object The object to inspect.
 * @param {Object} source The object of property values to match.
 * @param {Array} matchData The property names, values, and compare flags to match.
 * @param {Function} [customizer] The function to customize comparisons.
 * @returns {boolean} Returns `true` if `object` is a match, else `false`.
 *//**
 * Checks if `value` is suitable for strict equality comparisons, i.e. `===`.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` if suitable for strict
 *  equality comparisons, else `false`.
 *//**
 * Gets the property names, values, and compare flags of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the match data of `object`.
 *//**
 * A specialized version of `matchesProperty` for source values suitable
 * for strict equality comparisons, i.e. `===`.
 *
 * @private
 * @param {string} key The key of the property to get.
 * @param {*} srcValue The value to match.
 * @returns {Function} Returns the new spec function.
 *//**
 * The base implementation of `_.matches` which doesn't clone `source`.
 *
 * @private
 * @param {Object} source The object of property values to match.
 * @returns {Function} Returns the new spec function.
 *//**
 * Checks if `value` is classified as a `Symbol` primitive or object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
 * @example
 *
 * _.isSymbol(Symbol.iterator);
 * // => true
 *
 * _.isSymbol('abc');
 * // => false
 *//**
 * Checks if `value` is a property name and not a property path.
 *
 * @private
 * @param {*} value The value to check.
 * @param {Object} [object] The object to query keys on.
 * @returns {boolean} Returns `true` if `value` is a property name, else `false`.
 *//**
 * Creates a function that memoizes the result of `func`. If `resolver` is
 * provided, it determines the cache key for storing the result based on the
 * arguments provided to the memoized function. By default, the first argument
 * provided to the memoized function is used as the map cache key. The `func`
 * is invoked with the `this` binding of the memoized function.
 *
 * **Note:** The cache is exposed as the `cache` property on the memoized
 * function. Its creation may be customized by replacing the `_.memoize.Cache`
 * constructor with one whose instances implement the
 * [`Map`](http://ecma-international.org/ecma-262/7.0/#sec-properties-of-the-map-prototype-object)
 * method interface of `clear`, `delete`, `get`, `has`, and `set`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Function
 * @param {Function} func The function to have its output memoized.
 * @param {Function} [resolver] The function to resolve the cache key.
 * @returns {Function} Returns the new memoized function.
 * @example
 *
 * var object = { 'a': 1, 'b': 2 };
 * var other = { 'c': 3, 'd': 4 };
 *
 * var values = _.memoize(_.values);
 * values(object);
 * // => [1, 2]
 *
 * values(other);
 * // => [3, 4]
 *
 * object.a = 2;
 * values(object);
 * // => [1, 2]
 *
 * // Modify the result cache.
 * values.cache.set(object, ['a', 'b']);
 * values(object);
 * // => ['a', 'b']
 *
 * // Replace `_.memoize.Cache`.
 * _.memoize.Cache = WeakMap;
 */function c(e,t){if('function'!=typeof e||null!=t&&'function'!=typeof t)throw new TypeError(Qt);var n=function(){var a=arguments,o=t?t.apply(this,a):a[0],r=n.cache;if(r.has(o))return r.get(o);var d=e.apply(this,a);return n.cache=r.set(o,d)||r,d};return n.cache=new(c.Cache||le),n}// Expose `MapCache`.
/**
 * A specialized version of `_.memoize` which clears the memoized function's
 * cache when it exceeds `MAX_MEMOIZE_SIZE`.
 *
 * @private
 * @param {Function} func The function to have its output memoized.
 * @returns {Function} Returns the new memoized function.
 *//**
 * A specialized version of `_.map` for arrays without support for iteratee
 * shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the new mapped array.
 *//**
 * The base implementation of `_.toString` which doesn't convert nullish
 * values to empty strings.
 *
 * @private
 * @param {*} value The value to process.
 * @returns {string} Returns the string.
 */function l(e){// Exit early for strings to avoid a performance hit in some environments.
if('string'==typeof e)return e;if(Ae(e))// Recursively convert values (susceptible to call stack limits).
return Jt(e,l)+'';if(Wt(e))return nn?nn.call(e):'';var t=e+'';return'0'==t&&1/e==-en?'-0':t}/**
 * Converts `value` to a string. An empty string is returned for `null`
 * and `undefined` values. The sign of `-0` is preserved.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to convert.
 * @returns {string} Returns the converted string.
 * @example
 *
 * _.toString(null);
 * // => ''
 *
 * _.toString(-0);
 * // => '-0'
 *
 * _.toString([1, 2, 3]);
 * // => '1,2,3'
 *//**
 * Casts `value` to a path array if it's not one.
 *
 * @private
 * @param {*} value The value to inspect.
 * @param {Object} [object] The object to query keys on.
 * @returns {Array} Returns the cast property path array.
 *//**
 * Converts `value` to a string key if it's not a string or symbol.
 *
 * @private
 * @param {*} value The value to inspect.
 * @returns {string|symbol} Returns the key.
 *//**
 * The base implementation of `_.get` without support for default values.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Array|string} path The path of the property to get.
 * @returns {*} Returns the resolved value.
 *//**
 * Gets the value at `path` of `object`. If the resolved value is
 * `undefined`, the `defaultValue` is returned in its place.
 *
 * @static
 * @memberOf _
 * @since 3.7.0
 * @category Object
 * @param {Object} object The object to query.
 * @param {Array|string} path The path of the property to get.
 * @param {*} [defaultValue] The value returned for `undefined` resolved values.
 * @returns {*} Returns the resolved value.
 * @example
 *
 * var object = { 'a': [{ 'b': { 'c': 3 } }] };
 *
 * _.get(object, 'a[0].b.c');
 * // => 3
 *
 * _.get(object, ['a', '0', 'b', 'c']);
 * // => 3
 *
 * _.get(object, 'a.b.c', 'default');
 * // => 'default'
 *//**
 * The base implementation of `_.hasIn` without support for deep paths.
 *
 * @private
 * @param {Object} [object] The object to query.
 * @param {Array|string} key The key to check.
 * @returns {boolean} Returns `true` if `key` exists, else `false`.
 *//**
 * Checks if `path` exists on `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Array|string} path The path to check.
 * @param {Function} hasFunc The function to check properties.
 * @returns {boolean} Returns `true` if `path` exists, else `false`.
 *//**
 * Checks if `path` is a direct or inherited property of `object`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Object
 * @param {Object} object The object to query.
 * @param {Array|string} path The path to check.
 * @returns {boolean} Returns `true` if `path` exists, else `false`.
 * @example
 *
 * var object = _.create({ 'a': _.create({ 'b': 2 }) });
 *
 * _.hasIn(object, 'a');
 * // => true
 *
 * _.hasIn(object, 'a.b');
 * // => true
 *
 * _.hasIn(object, ['a', 'b']);
 * // => true
 *
 * _.hasIn(object, 'b');
 * // => false
 *//**
 * The base implementation of `_.matchesProperty` which doesn't clone `srcValue`.
 *
 * @private
 * @param {string} path The path of the property to get.
 * @param {*} srcValue The value to match.
 * @returns {Function} Returns the new spec function.
 *//**
 * This method returns the first argument it receives.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Util
 * @param {*} value Any value.
 * @returns {*} Returns `value`.
 * @example
 *
 * var object = { 'a': 1 };
 *
 * console.log(_.identity(object) === object);
 * // => true
 *//**
 * The base implementation of `_.property` without support for deep paths.
 *
 * @private
 * @param {string} key The key of the property to get.
 * @returns {Function} Returns the new accessor function.
 *//**
 * A specialized version of `baseProperty` which supports deep paths.
 *
 * @private
 * @param {Array|string} path The path of the property to get.
 * @returns {Function} Returns the new accessor function.
 *//**
 * Creates a function that returns the value at `path` of a given object.
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Util
 * @param {Array|string} path The path of the property to get.
 * @returns {Function} Returns the new accessor function.
 * @example
 *
 * var objects = [
 *   { 'a': { 'b': 2 } },
 *   { 'a': { 'b': 1 } }
 * ];
 *
 * _.map(objects, _.property('a.b'));
 * // => [2, 1]
 *
 * _.map(_.sortBy(objects, _.property(['a', 'b'])), 'a.b');
 * // => [1, 2]
 *//**
 * The base implementation of `_.iteratee`.
 *
 * @private
 * @param {*} [value=_.identity] The value to convert to an iteratee.
 * @returns {Function} Returns the iteratee.
 *//**
 * Creates a `_.find` or `_.findLast` function.
 *
 * @private
 * @param {Function} findIndexFunc The function to find the collection index.
 * @returns {Function} Returns the new find function.
 *//**
 * The base implementation of `_.findIndex` and `_.findLastIndex` without
 * support for iteratee shorthands.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {Function} predicate The function invoked per iteration.
 * @param {number} fromIndex The index to search from.
 * @param {boolean} [fromRight] Specify iterating from right to left.
 * @returns {number} Returns the index of the matched value, else `-1`.
 *//**
 * Converts `value` to a number.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to process.
 * @returns {number} Returns the number.
 * @example
 *
 * _.toNumber(3.2);
 * // => 3.2
 *
 * _.toNumber(Number.MIN_VALUE);
 * // => 5e-324
 *
 * _.toNumber(Infinity);
 * // => Infinity
 *
 * _.toNumber('3.2');
 * // => 3.2
 *//**
 * Converts `value` to a finite number.
 *
 * @static
 * @memberOf _
 * @since 4.12.0
 * @category Lang
 * @param {*} value The value to convert.
 * @returns {number} Returns the converted number.
 * @example
 *
 * _.toFinite(3.2);
 * // => 3.2
 *
 * _.toFinite(Number.MIN_VALUE);
 * // => 5e-324
 *
 * _.toFinite(Infinity);
 * // => 1.7976931348623157e+308
 *
 * _.toFinite('3.2');
 * // => 3.2
 *//**
 * Converts `value` to an integer.
 *
 * **Note:** This method is loosely based on
 * [`ToInteger`](http://www.ecma-international.org/ecma-262/7.0/#sec-tointeger).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to convert.
 * @returns {number} Returns the converted integer.
 * @example
 *
 * _.toInteger(3.2);
 * // => 3
 *
 * _.toInteger(Number.MIN_VALUE);
 * // => 0
 *
 * _.toInteger(Infinity);
 * // => 1.7976931348623157e+308
 *
 * _.toInteger('3.2');
 * // => 3
 *//**
 * This method is like `_.find` except that it returns the index of the first
 * element `predicate` returns truthy for instead of the element itself.
 *
 * @static
 * @memberOf _
 * @since 1.1.0
 * @category Array
 * @param {Array} array The array to inspect.
 * @param {Function} [predicate=_.identity] The function invoked per iteration.
 * @param {number} [fromIndex=0] The index to search from.
 * @returns {number} Returns the index of the found element, else `-1`.
 * @example
 *
 * var users = [
 *   { 'user': 'barney',  'active': false },
 *   { 'user': 'fred',    'active': false },
 *   { 'user': 'pebbles', 'active': true }
 * ];
 *
 * _.findIndex(users, function(o) { return o.user == 'barney'; });
 * // => 0
 *
 * // The `_.matches` iteratee shorthand.
 * _.findIndex(users, { 'user': 'fred', 'active': false });
 * // => 1
 *
 * // The `_.matchesProperty` iteratee shorthand.
 * _.findIndex(users, ['active', false]);
 * // => 0
 *
 * // The `_.property` iteratee shorthand.
 * _.findIndex(users, 'active');
 * // => 2
 */n=n&&n.hasOwnProperty('default')?n['default']:n;var h=function(e,t){return e===t||e!==e&&t!==t},_=function(e,t){for(var n=e.length;n--;)if(h(e[n][0],t))return n;return-1},y=Array.prototype,u=y.splice;/** Used for built-in method references. *//** Built-in value references. */a.prototype.clear=function(){this.__data__=[],this.size=0},a.prototype['delete']=function(e){var t=this.__data__,n=_(t,e);if(0>n)return!1;var a=t.length-1;return n==a?t.pop():u.call(t,n,1),--this.size,!0},a.prototype.get=function(e){var t=this.__data__,n=_(t,e);return 0>n?void 0:t[n][1]},a.prototype.has=function(e){return-1<_(this.__data__,e)},a.prototype.set=function(e,t){var n=this.__data__,a=_(n,e);return 0>a?(++this.size,n.push([e,t])):n[a][1]=t,this};var f=a,g='undefined'==typeof window?'undefined'==typeof global?'undefined'==typeof self?{}:self:global:window,b='object'==typeof g&&g&&g.Object===Object&&g,j=b,m='object'==typeof self&&self&&self.Object===Object&&self,x=j||m||Function('return this')(),P=x,O=P.Symbol,w=O,A=Object.prototype,z=A.hasOwnProperty,k=A.toString,E=w?w.toStringTag:void 0,C=function(e){var t=z.call(e,E),n=e[E];try{e[E]=void 0}catch(t){}var a=k.call(e);return t?e[E]=n:delete e[E],a},S=Object.prototype,v=S.toString,T=function(e){return v.call(e)},D=w?w.toStringTag:void 0,B=function(e){return null==e?void 0===e?'[object Undefined]':'[object Null]':D&&D in Object(e)?C(e):T(e)},M=function(e){var t=typeof e;return null!=e&&('object'==t||'function'==t)},L=function(e){if(!M(e))return!1;// The use of `Object#toString` avoids issues with the `typeof` operator
// in Safari 9 which returns 'object' for typed arrays and other constructors.
var t=B(e);return t=='[object Function]'||t=='[object GeneratorFunction]'||t=='[object AsyncFunction]'||t=='[object Proxy]'},$=P['__core-js_shared__'],K=$,F=function(){var e=/[^.]+$/.exec(K&&K.keys&&K.keys.IE_PROTO||'');return e?'Symbol(src)_1.'+e:''}(),U=function(e){return!!F&&F in e},I=Function.prototype,V=I.toString,R=function(e){if(null!=e){try{return V.call(e)}catch(t){}try{return e+''}catch(t){}}return''},W=/[\\^$.*+?()[\]{}|]/g,N=/^\[object .+?Constructor\]$/,G=Function.prototype,H=Object.prototype,Q=G.toString,X=H.hasOwnProperty,Y=RegExp('^'+Q.call(X).replace(W,'\\$&').replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,'$1.*?')+'$'),Z=function(e){if(!M(e)||U(e))return!1;var t=L(e)?Y:N;return t.test(R(e))},q=function(e,t){return null==e?void 0:e[t]},J=function(e,t){var n=q(e,t);return Z(n)?n:void 0},ee=J(P,'Map'),te=ee,ne=J(Object,'create'),ae=ne,oe=Object.prototype,re=oe.hasOwnProperty,de=Object.prototype,se=de.hasOwnProperty;/** Detect free variable `self`. *//** Used as a reference to the global object. *//** Built-in value references. *//** Used for built-in method references. *//** Used to check objects for own properties. *//**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 *//** Built-in value references. *//** Used for built-in method references. *//**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 *//** `Object#toString` result references. *//** Built-in value references. *//** `Object#toString` result references. *//** Used to detect overreaching core-js shims. *//** Used to detect methods masquerading as native. *//** Used for built-in method references. *//** Used to resolve the decompiled source of functions. *//**
 * Used to match `RegExp`
 * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
 *//** Used to detect host constructors (Safari). *//** Used for built-in method references. *//** Used to resolve the decompiled source of functions. *//** Used to check objects for own properties. *//** Used to detect if a method is native. *//* Built-in method references that are verified to be native. *//* Built-in method references that are verified to be native. *//** Used to stand-in for `undefined` hash values. *//** Used for built-in method references. *//** Used to check objects for own properties. *//** Used for built-in method references. *//** Used to check objects for own properties. *//** Used to stand-in for `undefined` hash values. */r.prototype.clear=function(){this.__data__=ae?ae(null):{},this.size=0},r.prototype['delete']=function(e){var t=this.has(e)&&delete this.__data__[e];return this.size-=t?1:0,t},r.prototype.get=function(e){var t=this.__data__;if(ae){var n=t[e];return n==='__lodash_hash_undefined__'?void 0:n}return re.call(t,e)?t[e]:void 0},r.prototype.has=function(e){var t=this.__data__;return ae?t[e]!==void 0:se.call(t,e)},r.prototype.set=function(e,t){var n=this.__data__;return this.size+=this.has(e)?0:1,n[e]=ae&&void 0===t?'__lodash_hash_undefined__':t,this};var pe=r,ie=function(e){var t=typeof e;return'string'==t||'number'==t||'symbol'==t||'boolean'==t?'__proto__'!==e:null===e},ce=function(e,t){var n=e.__data__;return ie(t)?n['string'==typeof t?'string':'hash']:n.map};d.prototype.clear=function(){this.size=0,this.__data__={hash:new pe,map:new(te||f),string:new pe}},d.prototype['delete']=function(e){var t=ce(this,e)['delete'](e);return this.size-=t?1:0,t},d.prototype.get=function(e){return ce(this,e).get(e)},d.prototype.has=function(e){return ce(this,e).has(e)},d.prototype.set=function(e,t){var n=ce(this,e),a=n.size;return n.set(e,t),this.size+=n.size==a?0:1,this};var le=d;/** Used as the size to enable large array optimizations. */s.prototype.clear=function(){this.__data__=new f,this.size=0},s.prototype['delete']=function(e){var t=this.__data__,n=t['delete'](e);return this.size=t.size,n},s.prototype.get=function(e){return this.__data__.get(e)},s.prototype.has=function(e){return this.__data__.has(e)},s.prototype.set=function(e,t){var n=this.__data__;if(n instanceof f){var a=n.__data__;if(!te||a.length<200-1)return a.push([e,t]),this.size=++n.size,this;n=this.__data__=new le(a)}return n.set(e,t),this.size=n.size,this};var he=s;/** Used to stand-in for `undefined` hash values. */p.prototype.add=p.prototype.push=function(e){return this.__data__.set(e,'__lodash_hash_undefined__'),this},p.prototype.has=function(e){return this.__data__.has(e)};var _e=function(e,t){for(var n=-1,a=null==e?0:e.length;++n<a;)if(t(e[n],n,e))return!0;return!1},ye=function(e,t){return e.has(t)},ue=function(e,t,n,a,o,r){var d=n&1,s=e.length,i=t.length;if(s!=i&&!(d&&i>s))return!1;// Assume cyclic values are equal.
var c=r.get(e);if(c&&r.get(t))return c==t;var l=-1,h=!0,_=n&2?new p:void 0;// Ignore non-index properties.
for(r.set(e,t),r.set(t,e);++l<s;){var y=e[l],u=t[l];if(a)var f=d?a(u,y,l,t,e,r):a(y,u,l,e,t,r);if(void 0!==f){if(f)continue;h=!1;break}// Recursively compare arrays (susceptible to call stack limits).
if(_){if(!_e(t,function(e,t){if(!ye(_,t)&&(y===e||o(y,e,n,a,r)))return _.push(t)})){h=!1;break}}else if(!(y===u||o(y,u,n,a,r))){h=!1;break}}return r['delete'](e),r['delete'](t),h},fe=P.Uint8Array,ge=fe,be=function(e){var t=-1,n=Array(e.size);return e.forEach(function(e,a){n[++t]=[a,e]}),n},je=function(e){var t=-1,n=Array(e.size);return e.forEach(function(e){n[++t]=e}),n},me=w?w.prototype:void 0,xe=me?me.valueOf:void 0,Pe=function(e,t,n,a,o,r,d){switch(n){case'[object DataView]':if(e.byteLength!=t.byteLength||e.byteOffset!=t.byteOffset)return!1;e=e.buffer,t=t.buffer;case'[object ArrayBuffer]':return e.byteLength==t.byteLength&&r(new ge(e),new ge(t));case'[object Boolean]':case'[object Date]':case'[object Number]':// Coerce booleans to `1` or `0` and dates to milliseconds.
// Invalid dates are coerced to `NaN`.
return h(+e,+t);case'[object Error]':return e.name==t.name&&e.message==t.message;case'[object RegExp]':case'[object String]':// Coerce regexes to strings and treat strings, primitives and objects,
// as equal. See http://www.ecma-international.org/ecma-262/7.0/#sec-regexp.prototype.tostring
// for more details.
return e==t+'';case'[object Map]':var s=be;case'[object Set]':var p=a&1;if(s||(s=je),e.size!=t.size&&!p)return!1;// Assume cyclic values are equal.
var i=d.get(e);if(i)return i==t;a|=2,d.set(e,t);var c=ue(s(e),s(t),a,o,r,d);return d['delete'](e),c;case'[object Symbol]':if(xe)return xe.call(e)==xe.call(t);}return!1},Oe=function(e,t){for(var n=-1,a=t.length,o=e.length;++n<a;)e[o+n]=t[n];return e},we=Array.isArray,Ae=we,ze=function(e,t,n){var a=t(e);return Ae(e)?a:Oe(a,n(e))},ke=function(e,t){for(var n=-1,a=null==e?0:e.length,o=0,r=[];++n<a;){var d=e[n];t(d,n,e)&&(r[o++]=d)}return r},Ee=Object.prototype,Ce=Ee.propertyIsEnumerable,Se=Object.getOwnPropertySymbols,ve=Se?function(e){return null==e?[]:(e=Object(e),ke(Se(e),function(t){return Ce.call(e,t)}))}:function(){return[]},Te=function(e,t){for(var n=-1,a=Array(e);++n<e;)a[n]=t(n);return a},De=function(e){return null!=e&&'object'==typeof e},Be=function(e){return De(e)&&B(e)=='[object Arguments]'},Me=Object.prototype,Le=Me.hasOwnProperty,$e=Me.propertyIsEnumerable,Ke=Be(function(){return arguments}())?Be:function(e){return De(e)&&Le.call(e,'callee')&&!$e.call(e,'callee')},Fe=Ke,Ue=function(){return!1},Ie=o(function(e,t){/** Detect free variable `exports`. */var n=t&&!t.nodeType&&t,a=n&&!0&&e&&!e.nodeType&&e,o=a&&a.exports===n,r=o?P.Buffer:void 0,d=r?r.isBuffer:void 0;/** Detect free variable `module`. *//** Detect the popular CommonJS extension `module.exports`. *//** Built-in value references. *//* Built-in method references for those with the same name as other `lodash` methods. *//**
 * Checks if `value` is a buffer.
 *
 * @static
 * @memberOf _
 * @since 4.3.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a buffer, else `false`.
 * @example
 *
 * _.isBuffer(new Buffer(2));
 * // => true
 *
 * _.isBuffer(new Uint8Array(2));
 * // => false
 */e.exports=d||Ue}),Ve=/^(?:0|[1-9]\d*)$/,Re=function(e,t){return t=null==t?9007199254740991:t,!!t&&('number'==typeof e||Ve.test(e))&&-1<e&&0==e%1&&e<t},We=function(e){return'number'==typeof e&&-1<e&&0==e%1&&e<=9007199254740991},Ne={};/** Used to compose bitmasks for value comparisons. *//** Built-in value references. *//** Used to compose bitmasks for value comparisons. *//** `Object#toString` result references. *//** Used to convert symbols to primitives and strings. *//**
 * Checks if `value` is classified as an `Array` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an array, else `false`.
 * @example
 *
 * _.isArray([1, 2, 3]);
 * // => true
 *
 * _.isArray(document.body.children);
 * // => false
 *
 * _.isArray('abc');
 * // => false
 *
 * _.isArray(_.noop);
 * // => false
 *//** Used for built-in method references. *//** Built-in value references. *//* Built-in method references for those with the same name as other `lodash` methods. *//**
 * Creates an array of the own enumerable symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of symbols.
 *//** `Object#toString` result references. *//** Used for built-in method references. *//** Used to check objects for own properties. *//** Built-in value references. *//**
 * Checks if `value` is likely an `arguments` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an `arguments` object,
 *  else `false`.
 * @example
 *
 * _.isArguments(function() { return arguments; }());
 * // => true
 *
 * _.isArguments([1, 2, 3]);
 * // => false
 *//** Used as references for various `Number` constants. *//** Used to detect unsigned integer values. *//** Used as references for various `Number` constants. *//** `Object#toString` result references. *//** Used to identify `toStringTag` values of typed arrays. */Ne['[object Float32Array]']=Ne['[object Float64Array]']=Ne['[object Int8Array]']=Ne['[object Int16Array]']=Ne['[object Int32Array]']=Ne['[object Uint8Array]']=Ne['[object Uint8ClampedArray]']=Ne['[object Uint16Array]']=Ne['[object Uint32Array]']=!0,Ne['[object Arguments]']=Ne['[object Array]']=Ne['[object ArrayBuffer]']=Ne['[object Boolean]']=Ne['[object DataView]']=Ne['[object Date]']=Ne['[object Error]']=Ne['[object Function]']=Ne['[object Map]']=Ne['[object Number]']=Ne['[object Object]']=Ne['[object RegExp]']=Ne['[object Set]']=Ne['[object String]']=Ne['[object WeakMap]']=!1;var Ge=o(function(e,t){/** Detect free variable `exports`. */var n=t&&!t.nodeType&&t,a=n&&!0&&e&&!e.nodeType&&e,o=a&&a.exports===n,r=o&&j.process,d=function(){try{return r&&r.binding&&r.binding('util')}catch(t){}}();/** Detect free variable `module`. *//** Detect the popular CommonJS extension `module.exports`. *//** Detect free variable `process` from Node.js. *//** Used to access faster Node.js helpers. */e.exports=d}),He=Ge&&Ge.isTypedArray,Qe=He?function(e){return function(t){return e(t)}}(He):function(e){return De(e)&&We(e.length)&&!!Ne[B(e)]},Xe=Qe,Ye=Object.prototype,Ze=Ye.hasOwnProperty,qe=function(e,t){var n=Ae(e),a=!n&&Fe(e),o=!n&&!a&&Ie(e),r=!n&&!a&&!o&&Xe(e),d=n||a||o||r,s=d?Te(e.length,String):[],p=s.length;for(var i in e)(t||Ze.call(e,i))&&!(d&&(// Safari 9 has enumerable `arguments.length` in strict mode.
'length'==i||// Node.js 0.10 has enumerable non-index properties on buffers.
o&&('offset'==i||'parent'==i)||// PhantomJS 2 has enumerable non-index properties on typed arrays.
r&&('buffer'==i||'byteLength'==i||'byteOffset'==i)||// Skip index properties.
Re(i,p)))&&s.push(i);return s},Je=Object.prototype,et=function(e){var t=e&&e.constructor,n='function'==typeof t&&t.prototype||Je;return e===n},tt=function(e,t){return function(n){return e(t(n))}}(Object.keys,Object),nt=Object.prototype,at=nt.hasOwnProperty,ot=function(e){if(!et(e))return tt(e);var t=[];for(var n in Object(e))at.call(e,n)&&'constructor'!=n&&t.push(n);return t},rt=function(e){return null!=e&&We(e.length)&&!L(e)},dt=function(e){return rt(e)?qe(e):ot(e)},st=function(e){return ze(e,dt,ve)},pt=Object.prototype,it=pt.hasOwnProperty,ct=function(e,t,n,a,o,r){var d=n&1,s=st(e),p=s.length,i=st(t),c=i.length;if(p!=c&&!d)return!1;for(var l,h=p;h--;)if(l=s[h],d?!(l in t):!it.call(t,l))return!1;// Assume cyclic values are equal.
var _=r.get(e);if(_&&r.get(t))return _==t;var y=!0;r.set(e,t),r.set(t,e);for(var u=d;++h<p;){l=s[h];var f=e[l],g=t[l];if(a)var b=d?a(g,f,l,t,e,r):a(f,g,l,e,t,r);// Recursively compare objects (susceptible to call stack limits).
if(void 0===b?!(f===g||o(f,g,n,a,r)):!b){y=!1;break}u||(u='constructor'==l)}if(y&&!u){var j=e.constructor,m=t.constructor;// Non `Object` object instances with different constructors are not equal.
j!=m&&'constructor'in e&&'constructor'in t&&!('function'==typeof j&&j instanceof j&&'function'==typeof m&&m instanceof m)&&(y=!1)}return r['delete'](e),r['delete'](t),y},lt=J(P,'DataView'),ht=lt,_t=J(P,'Promise'),yt=_t,ut=J(P,'Set'),ft=ut,gt=J(P,'WeakMap'),bt=gt,jt='[object Map]',mt='[object Promise]',xt='[object Set]',Pt='[object WeakMap]',Ot='[object DataView]',wt=R(ht),At=R(te),zt=R(yt),kt=R(ft),Et=R(bt),Ct=B;/* Node.js helper references. *//**
 * Checks if `value` is classified as a typed array.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
 * @example
 *
 * _.isTypedArray(new Uint8Array);
 * // => true
 *
 * _.isTypedArray([]);
 * // => false
 *//** Used for built-in method references. *//** Used to check objects for own properties. *//** Used for built-in method references. *//* Built-in method references for those with the same name as other `lodash` methods. *//** Used for built-in method references. *//** Used to check objects for own properties. *//** Used to compose bitmasks for value comparisons. *//** Used for built-in method references. *//** Used to check objects for own properties. *//* Built-in method references that are verified to be native. *//* Built-in method references that are verified to be native. *//* Built-in method references that are verified to be native. *//* Built-in method references that are verified to be native. *//** `Object#toString` result references. *//** Used to detect maps, sets, and weakmaps. *//**
 * Gets the `toStringTag` of `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */// Fallback for data views, maps, sets, and weak maps in IE 11 and promises in Node.js < 6.
(ht&&Ct(new ht(new ArrayBuffer(1)))!=Ot||te&&Ct(new te)!=jt||yt&&Ct(yt.resolve())!=mt||ft&&Ct(new ft)!=xt||bt&&Ct(new bt)!=Pt)&&(Ct=function(e){var t=B(e),n=t=='[object Object]'?e.constructor:void 0,a=n?R(n):'';if(a)switch(a){case wt:return Ot;case At:return jt;case zt:return mt;case kt:return xt;case Et:return Pt;}return t});var St=Ct,vt='[object Arguments]',Tt='[object Array]',Dt='[object Object]',Bt=Object.prototype,Mt=Bt.hasOwnProperty,Lt=function(e,t,n,a,o,r){var d=Ae(e),s=Ae(t),p=d?Tt:St(e),i=s?Tt:St(t);p=p==vt?Dt:p,i=i==vt?Dt:i;var c=p==Dt,l=i==Dt,h=p==i;if(h&&Ie(e)){if(!Ie(t))return!1;d=!0,c=!1}if(h&&!c)return r||(r=new he),d||Xe(e)?ue(e,t,n,a,o,r):Pe(e,t,p,n,a,o,r);if(!(n&1)){var _=c&&Mt.call(e,'__wrapped__'),y=l&&Mt.call(t,'__wrapped__');if(_||y){var u=_?e.value():e,f=y?t.value():t;return r||(r=new he),o(u,f,n,a,r)}}return!!h&&(r||(r=new he),ct(e,t,n,a,o,r))},$t=i,Kt=function(e,t){return $t(e,t)},Ft=function(e,t,n,a){var o=n.length,r=o,d=!a;if(null==e)return!r;for(e=Object(e);o--;){var s=n[o];if(d&&s[2]?s[1]!==e[s[0]]:!(s[0]in e))return!1}for(;++o<r;){s=n[o];var p=s[0],i=e[p],c=s[1];if(!(d&&s[2])){var l=new he;if(a)var h=a(i,c,p,e,t,l);if(void 0===h?!$t(c,i,1|2,a,l):!h)return!1}else if(void 0===i&&!(p in e))return!1}return!0},Ut=function(e){return e===e&&!M(e)},It=function(e){for(var t=dt(e),n=t.length;n--;){var a=t[n],o=e[a];t[n]=[a,o,Ut(o)]}return t},Vt=function(e,t){return function(n){return null!=n&&n[e]===t&&(t!==void 0||e in Object(n))}},Rt=function(e){var t=It(e);return 1==t.length&&t[0][2]?Vt(t[0][0],t[0][1]):function(n){return n===e||Ft(n,e,t)}},Wt=function(e){return'symbol'==typeof e||De(e)&&B(e)=='[object Symbol]'},Nt=/\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,Gt=/^\w*$/,Ht=function(e,t){if(Ae(e))return!1;var n=typeof e;return'number'==n||'symbol'==n||'boolean'==n||null==e||Wt(e)||Gt.test(e)||!Nt.test(e)||null!=t&&e in Object(t)},Qt='Expected a function';/** Used to compose bitmasks for value comparisons. *//** `Object#toString` result references. *//** Used for built-in method references. *//** Used to check objects for own properties. *//** Used to compose bitmasks for value comparisons. *//** `Object#toString` result references. *//** Used to match property names within property paths. *//** Error message constants. */c.Cache=le;var Xt=/^\./,Yt=/[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g,Zt=/\\(\\)?/g,qt=function(e){var t=c(e,function(e){return n.size===500&&n.clear(),e}),n=t.cache;return t}(function(e){var t=[];return Xt.test(e)&&t.push(''),e.replace(Yt,function(e,n,a,o){t.push(a?o.replace(Zt,'$1'):n||e)}),t}),Jt=function(e,t){for(var n=-1,a=null==e?0:e.length,o=Array(a);++n<a;)o[n]=t(e[n],n,e);return o},en=1/0,tn=w?w.prototype:void 0,nn=tn?tn.toString:void 0,an=function(e){return null==e?'':l(e)},on=function(e,t){return Ae(e)?e:Ht(e,t)?[e]:qt(an(e))},rn=function(e){if('string'==typeof e||Wt(e))return e;var t=e+'';return'0'==t&&1/e==-(1/0)?'-0':t},dn=function(e,t){t=on(t,e);for(var n=0,a=t.length;null!=e&&n<a;)e=e[rn(t[n++])];return n&&n==a?e:void 0},sn=function(e,t,n){var a=null==e?void 0:dn(e,t);return a===void 0?n:a},pn=function(e,t){return null!=e&&t in Object(e)},cn=function(e,t,n){t=on(t,e);for(var a,o=-1,r=t.length,d=!1;++o<r&&(a=rn(t[o]),!!(d=null!=e&&n(e,a)));)e=e[a];return d||++o!=r?d:(r=null==e?0:e.length,!!r&&We(r)&&Re(a,r)&&(Ae(e)||Fe(e)))},ln=function(e,t){return null!=e&&cn(e,t,pn)},hn=function(e,t){return Ht(e)&&Ut(t)?Vt(rn(e),t):function(n){var a=sn(n,e);return a===void 0&&a===t?ln(n,e):$t(t,a,1|2)}},_n=function(e){return e},yn=function(e){return function(t){return null==t?void 0:t[e]}},un=function(e){return function(t){return dn(t,e)}},fn=function(e){return Ht(e)?yn(rn(e)):un(e)},gn=function(e){// Don't store the `typeof` result in a variable to avoid a JIT bug in Safari 9.
// See https://bugs.webkit.org/show_bug.cgi?id=156034 for more details.
return'function'==typeof e?e:null==e?_n:'object'==typeof e?Ae(e)?hn(e[0],e[1]):Rt(e):fn(e)},bn=function(e,t,n,a){for(var o=e.length,r=n+(a?1:-1);a?r--:++r<o;)if(t(e[r],r,e))return r;return-1},jn=0/0,mn=/^\s+|\s+$/g,xn=/^[-+]0x[0-9a-f]+$/i,Pn=/^0b[01]+$/i,On=/^0o[0-7]+$/i,wn=parseInt,An=function(e){if('number'==typeof e)return e;if(Wt(e))return jn;if(M(e)){var t='function'==typeof e.valueOf?e.valueOf():e;e=M(t)?t+'':t}if('string'!=typeof e)return 0===e?e:+e;e=e.replace(mn,'');var n=Pn.test(e);return n||On.test(e)?wn(e.slice(2),n?2:8):xn.test(e)?jn:+e},zn=1/0,kn=function(e){if(!e)return 0===e?e:0;if(e=An(e),e===zn||e===-zn){var t=0>e?-1:1;return t*1.7976931348623157e308}return e===e?e:0},En=function(e){var t=kn(e),n=t%1;return t===t?n?t-n:t:0},Cn=Math.max,Sn=function(e){return function(t,n,a){var o=Object(t);if(!rt(t)){var r=gn(n,3);t=dt(t),n=function(e){return r(o[e],e,o)}}var d=e(t,n,a);return-1<d?o[r?t[d]:d]:void 0}}(function(e,t,n){var a=null==e?0:e.length;if(!a)return-1;var o=null==n?0:En(n);return 0>o&&(o=Cn(a+o,0)),bn(e,gn(t,3),o)}),vn=Object.assign||function(e){for(var t,n=1;n<arguments.length;n++)for(var a in t=arguments[n],t)Object.prototype.hasOwnProperty.call(t,a)&&(e[a]=t[a]);return e},Tn=function(e,t){var n={};for(var a in e)0<=t.indexOf(a)||Object.prototype.hasOwnProperty.call(e,a)&&(n[a]=e[a]);return n};/** Used as the maximum memoize cache size. *//** Used to match property names within property paths. *//** Used to match backslashes in property paths. *//**
 * Converts `string` to a property path array.
 *
 * @private
 * @param {string} string The string to convert.
 * @returns {Array} Returns the property path array.
 *//** Used as references for various `Number` constants. *//** Used to convert symbols to primitives and strings. *//** Used as references for various `Number` constants. *//** Used to compose bitmasks for value comparisons. *//** Used as references for various `Number` constants. *//** Used to match leading and trailing whitespace. *//** Used to detect bad signed hexadecimal string values. *//** Used to detect binary string values. *//** Used to detect octal string values. *//** Built-in method references without a dependency on `root`. *//** Used as references for various `Number` constants. *//* Built-in method references for those with the same name as other `lodash` methods. *//**
 * Iterates over elements of `collection`, returning the first element
 * `predicate` returns truthy for. The predicate is invoked with three
 * arguments: (value, index|key, collection).
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Collection
 * @param {Array|Object} collection The collection to inspect.
 * @param {Function} [predicate=_.identity] The function invoked per iteration.
 * @param {number} [fromIndex=0] The index to search from.
 * @returns {*} Returns the matched element, else `undefined`.
 * @example
 *
 * var users = [
 *   { 'user': 'barney',  'age': 36, 'active': true },
 *   { 'user': 'fred',    'age': 40, 'active': false },
 *   { 'user': 'pebbles', 'age': 1,  'active': true }
 * ];
 *
 * _.find(users, function(o) { return o.age < 40; });
 * // => object for 'barney'
 *
 * // The `_.matches` iteratee shorthand.
 * _.find(users, { 'age': 1, 'active': true });
 * // => object for 'pebbles'
 *
 * // The `_.matchesProperty` iteratee shorthand.
 * _.find(users, ['active', false]);
 * // => object for 'fred'
 *
 * // The `_.property` iteratee shorthand.
 * _.find(users, 'active');
 * // => object for 'barney'
 */class Dn extends t.Component{constructor(...e){var t;return t=super(...e),this.handleOnClick=(e)=>{const t=this.chart_instance,{getDatasetAtEvent:n,getElementAtEvent:a,getElementsAtEvent:o,onElementsClick:r}=this.props;n&&n(t.getDatasetAtEvent(e),e),a&&a(t.getElementAtEvent(e),e),o&&o(t.getElementsAtEvent(e),e),r&&r(t.getElementsAtEvent(e),e)},this.ref=(e)=>{this.element=e},t}componentWillMount(){this.chart_instance=void 0}componentDidMount(){this.renderChart()}componentDidUpdate(){return this.props.redraw?(this.chart_instance.destroy(),void this.renderChart()):void this.updateChart()}shouldComponentUpdate(e){const{redraw:t,type:n,options:a,plugins:o,legend:r,height:d,width:s}=this.props;if(!0===e.redraw)return!0;if(d!==e.height||s!==e.width)return!0;if(n!==e.type)return!0;if(!Kt(r,e.legend))return!0;if(!Kt(a,e.options))return!0;const p=this.transformDataProp(e);return!Kt(this.shadowDataProp,p)||!Kt(o,e.plugins)}componentWillUnmount(){this.chart_instance.destroy()}transformDataProp(e){const{data:t}=e;if('function'==typeof t){const e=this.element;return t(e)}return t}// Chart.js directly mutates the data.dataset objects by adding _meta proprerty
// this makes impossible to compare the current and next data changes
// therefore we memoize the data prop while sending a fake to Chart.js for mutation.
// see https://github.com/chartjs/Chart.js/blob/master/src/core/core.controller.js#L615-L617
memoizeDataProps(){if(this.props.data){const e=this.transformDataProp(this.props);return this.shadowDataProp=vn({},e,{datasets:e.datasets&&e.datasets.map((e)=>vn({},e))}),e}}updateChart(){const{options:e}=this.props,t=this.memoizeDataProps(this.props);if(!this.chart_instance)return;e&&(this.chart_instance.options=n.helpers.configMerge(this.chart_instance.options,e));// Pipe datasets to chart instance datasets enabling
// seamless transitions
let a=this.chart_instance.config.data&&this.chart_instance.config.data.datasets||[];const o=t.datasets||[],r=a.map(this.props.datasetKeyProvider),d=o.map(this.props.datasetKeyProvider),s=o.filter((e)=>-1===r.indexOf(this.props.datasetKeyProvider(e)));// use the key provider to work out which series have been added/removed/changed
// process the updates (via a reverse for loop so we can safely splice deleted datasets out of the array
for(let e=a.length-1;0<=e;e-=1){const t=this.props.datasetKeyProvider(a[e]);if(-1===d.indexOf(t))a.splice(e,1);else{const n=Sn(o,(e)=>this.props.datasetKeyProvider(e)===t);if(n){a[e].data.splice(n.data.length),n.data.forEach((t,o)=>{a[e].data[o]=n.data[o]});const{data:t}=n,o=Tn(n,['data']);a[e]=vn({data:a[e].data},a[e],o)}}}// finally add any new series
s.forEach((e)=>a.push(e));const{datasets:p}=t,i=Tn(t,['datasets']);this.chart_instance.config.data=vn({},this.chart_instance.config.data,i),this.chart_instance.update()}renderChart(){const{options:e,legend:t,type:a,redraw:o,plugins:r}=this.props,d=this.element,s=this.memoizeDataProps();'undefined'==typeof t||Kt(Dn.defaultProps.legend,t)||(e.legend=t),this.chart_instance=new n(d,{type:a,data:s,options:e,plugins:r})}render(){const{height:e,width:n,onElementsClick:a}=this.props;return t.h('canvas',{ref:this.ref,height:e,width:n,onClick:this.handleOnClick})}}Dn.getLabelAsKey=(e)=>e.label,Dn.defaultProps={legend:{display:!0,position:'bottom'},type:'doughnut',height:150,width:300,redraw:!1,options:{},datasetKeyProvider:Dn.getLabelAsKey};class Bn extends t.Component{render(){return t.h(Dn,vn({},this.props,{ref:(e)=>this.chart_instance=e&&e.chart_instance,type:'doughnut'}))}}class Mn extends t.Component{render(){return t.h(Dn,vn({},this.props,{ref:(e)=>this.chart_instance=e&&e.chart_instance,type:'pie'}))}}class Ln extends t.Component{render(){return t.h(Dn,vn({},this.props,{ref:(e)=>this.chart_instance=e&&e.chart_instance,type:'line'}))}}class $n extends t.Component{render(){return t.h(Dn,vn({},this.props,{ref:(e)=>this.chart_instance=e&&e.chart_instance,type:'bar'}))}}class Kn extends t.Component{render(){return t.h(Dn,vn({},this.props,{ref:(e)=>this.chart_instance=e&&e.chart_instance,type:'horizontalBar'}))}}class Fn extends t.Component{render(){return t.h(Dn,vn({},this.props,{ref:(e)=>this.chart_instance=e&&e.chart_instance,type:'radar'}))}}class Un extends t.Component{render(){return t.h(Dn,vn({},this.props,{ref:(e)=>this.chart_instance=e&&e.chart_instance,type:'polarArea'}))}}class In extends t.Component{render(){return t.h(Dn,vn({},this.props,{ref:(e)=>this.chart_instance=e&&e.chart_instance,type:'bubble'}))}}class Vn extends t.Component{render(){return t.h(Dn,vn({},this.props,{ref:(e)=>this.chart_instance=e&&e.chart_instance,type:'scatter'}))}}const Rn=n.defaults;e['default']=Dn,e.Doughnut=Bn,e.Pie=Mn,e.Line=Ln,e.Bar=$n,e.HorizontalBar=Kn,e.Radar=Fn,e.Polar=Un,e.Bubble=In,e.Scatter=Vn,e.defaults=Rn,e.Chart=n,Object.defineProperty(e,'__esModule',{value:!0})});
